{secure} = require 'bongo'

Module = require './module'

Message = require './message'

module.exports = class Channel extends Module
  
  @share()
  
  @set
    sharedMethods :
      instance: ['subscribe','unsubscribe','publish']
  
    schema    :
      name      : String
      meta      : require 'bongo/bundles/meta'
    
    relationships :
      message:
        targetType: Message
        role: 'forum'

  @channels = {}

  @fetchPrivateChannel = secure ({server, account}, autoSubscribe, callback)->
    [callback, autoSubscribe] = [autoSubscribe, callback] unless callback
    autoSubscribe or= yes
    constructor = @
    name = "#{account._id}_private"
    channel = constructor.channels[name] or= new constructor name, server
    channel.subscribe account if autoSubscribe
    callback channel
    return

  constructor:(@name, @server)->
    super
    @subscribers = {}
    @constructor.channels[name] = @

  subscribe: secure (client)->
    {account} = client
    @subscribers[account._id] = account
  
  unsubscribe: secure ({account})->
    delete @subscribers[account._id]
  
  publish: secure ({account}, contents)->
    channel = @
    message = new Message account, contents
    message.save (err)->
      channel.emit 'error', err if err
      channel.addMessage message, (err)->
        throw err if err
        for own id, subscriber of channel.subscribers
          subscriber.emit? 'message', message, channel
        return
    @
  